clear;

%cantidad de iteraciones
cant   = 10;
result = [];
t0 = clock;
file = "data_youtube/input_youtube_complete.csv";

for i = 1 : cant+1
	t1 = clock;
	[obj_p2p,obj_cdn,time_p2p,t_p2p,time_cdn,t_cdn,time_ideal,t_ideal,iterations] = ejecutar_grasp( file, 2+i,3 );
	t2 = clock;

	result(i,1) = 2+i;
	result(i,2) = obj_p2p;
	result(i,3) = obj_cdn;
	result(i,4) = time_p2p;
	result(i,5) = time_cdn;
	result(i,6) = time_ideal;
	result(i,7) = etime(t2, t1);
	result(i,8) = t_p2p;
	result(i,9) = t_cdn;
	result(i,10) = t_ideal;
	result(i,11) = iterations;
	csvwrite( "data_youtube/result_superpeers.csv", result );
end

t9 = clock;
printf( "\n\n Bucle completado! %i ejecuciones del COP. Tiempo total: %i (segundos)\n\n\n", cant, etime(t9, t0) );

factors = result(:,1);

figure(1);
p2p_objectives = result(:,2);
cdn_objectives = result(:,3);
plot( factors, p2p_objectives, 'r' , factors, cdn_objectives, 'b' )

figure(2);
p2p_times = result(:,4);
cdn_times = result(:,5);
plot( factors, p2p_times, 'r' , factors, cdn_times, 'b' )
