<?php

include_once 'inc/config.php';
include_once 'inc/functions.php';
include_once 'inc/Execution_Manager.php';
include_once 'inc/Goalbit_File_Writer.php';

// Recibe por parametro la cantidad de ejecuciones (0 = inf)
if ( isset($argv[1]) )
    $exec_limit = $argv[1];
else
    $exec_limit = 0;


$dbc = mysql_connect( DBC_HOST, DBC_USER, DBC_PASS) or die('E1');
mysql_select_db ( DBC_DB, $dbc )  or die('E2');

// cantidad de ejecuciones
$exec_count = 0;
// librerias de chequeo
//$goalbit_writer = new Goalbit_File_Writer();
//$exec_manager   = new Execution_Manager();


while ( 1 )
{
    if ( $exec_limit != 0 && $exec_count >= $exec_limit )
        break;

    // Bajo datos del server
    $active_video = get_next_active_video();

    $wget_cmd = 'wget -r -A *watch*  --append-output='. BASE_DIR .'youtube.log -nv -l1 -np -nH -P"'. $active_video['path'] .'"  "http://www.youtube.com/'. $active_video['webpath'] .'"';

    echo "==> Running: $wget_cmd\n";
    exec($wget_cmd);


    foreach ( glob( $active_video['path'] .'/*watch*') as $filename ) 
    {
        if ( $exec_limit != 0 && $exec_count >= $exec_limit )
            break;

        echo "==> Processing: $filename\n";

        // Bajo nuevamente el archivo para recuperar la session de youtube
        //
        $web_path = str_replace( $active_video['path'], '', $filename );
        exec( 'rm  "'. $filename .'"' );
        exec( 'cd '. $active_video['path'] .'; wget "http://www.youtube.com'. $web_path .'"' );

        if ( !is_file($filename) )
        {
            echo "====> Problema con el WGet, no existe: $filename\n";
            continue;
        }

        $result = parse_youtube_webpage( $filename );
        $video_items = $result['video_item_list'];
        $video_views = $result['views'];
        $video_date  = $result['datetime'];

        $video_name = get_video_name_from_url( $filename );
        if ( $video_name == $active_video['name'] )
        {
            // It is the source video, just update views
            update_video_views( $video_name, $video_views );
            update_video_date( $video_name, $video_date );
            $video_id = $active_video['id'];
        }
        else
        {
            $video_id = insert_video( $video_name, $video_views, $video_date );
            if ( $video_id === false )
            {
                echo "====> Ya existe: $video_name en la BD\n";
                continue;
            }
        }

        foreach( $video_items as $item_url )
        {
            // Insert video item
            //var_dump( $item ); 
            $item_id  = insert_video_item( $video_id, $item_url );

            // Get video item information
            $video_cmd = './scripts/video_analyzer "'.$item_url.'"';
            exec( $video_cmd, $video_data, $result );
            if ( $result == 0 )
            {
                insert_video_item_info( $item_id, $video_data[0] );
                unset( $video_data );
            }
        }

        $exec_count ++;
    }
}

mysql_close($dbc);
?>