clear;

%cantidad de iteraciones
cant   = 10;
factor = 10;
result = [];
file = "data_youtube/input_youtube_complete.csv";
t0 = clock;

for i = 1 : cant+1
	t1 = clock;
	[o_p2p1,o_cdn1,t_p2p1,t_cdn1,o_p2p2,o_cdn2,t_p2p2,t_cdn2,o_p2p3,o_cdn3,t_p2p3,t_cdn3] = ejecutar_grasp_con_path_relinking( file, 6, factor^(i-1) );
	t2 = clock;

	result(i,1)  = i;
	result(i,2)  = o_p2p1;
	result(i,3)  = o_cdn1;
	result(i,4)  = t_p2p1;
	result(i,5)  = t_cdn1;
	result(i,6)  = " ";
	result(i,7)  = o_p2p2;
	result(i,8)  = o_cdn2;
	result(i,9)  = t_p2p2;
	result(i,10) = t_cdn2;
	result(i,11) = " ";
	result(i,12) = o_p2p3;
	result(i,13) = o_cdn3;
	result(i,14) = t_p2p3;
	result(i,15) = t_cdn3;
	result(i,16) = " ";
	result(i,17) = etime(t2, t1);

	csvwrite( "data_youtube/result_pathrelinking.csv", result );
end

t3 = clock;
printf( "\n\n Bucle completado! %i ejecuciones del COP. Tiempo total: %i (segundos)\n\n\n", cant, etime(t3, t0) );

factors = result(:,1);

figure(1);
p2p_times1 = result(:,4);
p2p_times2 = result(:,9);
p2p_times3 = result(:,14);
plot( factors, p2p_times1, 'r', factors, p2p_times2, 'g', factors, p2p_times3, 'b' )

